%
% Metodos de Euler explicito e implicito para a resolucao do problema 
% de valor inicial:  y' = lambda*y  com  y(0) = 1.
%
% L. N. Vicente, Dezembro de 2004.
%
%
lambda = -1 + 9i;
hmax   = - 2 * real(lambda) / (abs(lambda)^2)
%
t0 = 0;
y0 = 1;
%
T  = 10;
nh = 350;
h  = T/nh
%
u(1) = y0;
t    = t0;
%
sol(1)      = y0;
t_grelha(1) = t0;
%
for k=1:nh,
    t  = t + h;
%
    sol(k+1)      = exp(lambda*t);
    t_grelha(k+1) = t;
%
    u(k+1) = ( 1 + h*lambda )*u(k);
end
%
uu(1) = y0;
t     = t0;
%
for k=1:nh,
    uu(k+1) = uu(k) / ( 1 - h*lambda );
end
%
plot(t_grelha,real(u),':');
hold on;
plot(t_grelha,real(uu),'--');
plot(t_grelha,real(sol),'-');
hold off
%
% Fim.